---
title: Search on MDN
slug: MDN/Tools/Search
tags:
  - Guide
  - MDN Meta
  - Site-wide
  - Tools
---
<div>{{MDNSidebar}}</div>

<p class="summary"><span class="seoSummary">The on-site search feature of MDN offers a number of features that may not be available when using an external search engine to search for MDN articles. </span>This article describes how to leverage MDN's search engine.</p>

<h2 id="Basic_search_options">Basic search options</h2>

<h3 id="Filtering_results">Filtering results</h3>

<p>When viewing the results of a search query on MDN, you have the option of filtering the results by topic, skill level, and document type. This can be useful, for example, when you are looking for a method where the relevant keywords might appear in multiple contexts; you can use the topic filter to view only results in the API you are most interested in. These filters rely on the tags on pages to determine which pages to include or exclude (which is the reason for <a href="/en-US/docs/MDN/Contribute/Howto/Tag">properly tagging pages</a> when creating or editing them). You can apply the following types of filters:</p>

<dl>
 <dt>Topics</dt>
 <dd>Filter the results according to topic tags</dd>
 <dt>Skill level</dt>
 <dd>Filter based on <strong>Beginner</strong>, <strong>Intermediate</strong> or <strong>Advanced</strong> tags.</dd>
 <dt>Document type</dt>
 <dd>Filter the results based on tags <strong>Example</strong>, <strong>Guide</strong>, or <strong>Tools</strong>.</dd>
</dl>

<h2 id="Advanced_search_options">Advanced search options</h2>

<p>MDN has an advanced search mechanism that lets you search the page source — that is, the raw HTML of the site, with macros in place rather than their output — in order to find uses of specific macros, use of given HTML attributes, and the like.</p>

<p>There is not currently a user interface for this advanced search mechanism, but you can access it by URL. You can get the output either as a standard MDN search results page or in JSON format (the latter means you can use this mechanism from KumaScript code, for example). This section covers how to use it.</p>

<p><strong>Note:</strong> These search queries are not intended for the construction of URLs to be distributed; they're for use by tools and utilities. They could change in the future, and are not necessarily high-performance queries.</p>

<h3 id="Search_query_format">Search query format</h3>

<p>Advanced search queries are performed by constructing URLs with the appropriate parameters. The base URL is one of the following:</p>

<dl class="properties">
 <dt><code>https://developer.mozilla.org/en-US/search</code></dt>
 <dd>Use this base URL to get a standard MDN search results page as output.</dd>
 <dt><code>https://developer.mozilla.org/en-US/search.json</code></dt>
 <dd>Use this base URL to get the results in JSON format. See {{anch("JSON response body format")}} for information about the result format.</dd>
</dl>

<p>In addition, you need to add the appropriate parameters to get the results you want. You may use any combination of these:</p>

<dl>
 <dt><code>q=</code></dt>
 <dd>The search query to match. This is the same parameter used for basic search.</dd>
 <dt><code>locale=</code></dt>
 <dd>The locale to match against. By default, all locales are considered. You may also specify "all locales" with the wildcard <code>"*"</code>. For example, you can specify <code>locale=en-US</code> to limit a search to English pages.</dd>
 <dt><code>css_classnames=</code></dt>
 <dd>The CSS classes to match. This limits the search results to pages whose HTML includes at least one use of the specified classes.</dd>
 <dt><code>html_attributes=</code></dt>
 <dd>The HTML attribute text to match. This is a leading text search; that is, if the specified text appears at the beginning of an attribute string in the HTML, it's considered a match. See below for details.</dd>
 <dt><code>kumascript_macros=</code></dt>
 <dd>A list of one or more KumaScript macros to search for. This lets you find articles using a specific macro; this would be useful, for instance, if a macro is obsolete, or if its parameters have changed and you need to update existing uses.</dd>
 <dt><code>highlight=</code></dt>
 <dd>Must be either <code>true</code> or <code>false</code>; defaults to <code>true</code>. Determines whether the excerpt shows the page's first section or portions of the page that contain the query. If true, there will also be <code><a href="/en-US/docs/Web/HTML/Element/mark">&lt;mark&gt;</a></code> elements around result phrases that match the search query.</dd>
 <dt><code>per_page=</code></dt>
 <dd>Must be a number &lt;=100. By default Kuma displays 10 results per page. Use this parameter to choose a different value.</dd>
</dl>

<h3 id="Examples">Examples</h3>

<p>Here are some sample searches.</p>

<h4 id="Searching_by_locale">Searching by locale</h4>

<pre class="syntaxbox notranslate">https://developer.mozilla.org/en-US/search?locale=<var>en-US</var></pre>

<p>This example returns a list of all articles that are in English, with no other restrictions. At the time of writing, this results in 13513 pages (that'll be higher by the time you see this, of course, since we're constantly growing)!</p>

<h4 id="Searching_by_CSS_class_name">Searching by CSS class name</h4>

<pre class="syntaxbox notranslate">https://developer.mozilla.org/en-US/search?locale=en-US&amp;css_classnames=<var>smaller</var></pre>

<p>In this example, we add a search for uses of the CSS class <code>smaller</code>; at the time of writing, this narrowed the results down to 35 pages.</p>

<h4 id="Searching_by_HTML_attribute_string">Searching by HTML attribute string</h4>

<pre class="syntaxbox notranslate">https://developer.mozilla.org/en-US/search?locale=en-US&amp;html_attributes=<var>style</var></pre>

<p>Now we're looking for uses of the <code>style</code> attribute on HTML elements. At the time of writing, we found 6416 of them. This usage is deprecated on MDN; we are going to be replacing them all with uses of our standard classes instead.</p>

<p>You can also include the value of the attribute, but keep in mind that if you wish to include characters like <code>=</code> and <code>/</code> in your search, you'll need to URL-encode them. For example, to find pages that link to www.mozilla.org, you would do:</p>

<pre class="syntaxbox notranslate">https://developer.mozilla.org/en-US/search?locale=en-US&amp;html_attributes=<var>href%3D%22https%3A%2F%2Fwww.mozilla.org</var></pre>

<p>This search results in 98 results. That's a relatively low number of links to the www.mozilla.org site!</p>

<h4 id="Searching_for_KumaScript_macro_usage">Searching for KumaScript macro usage</h4>

<pre class="syntaxbox notranslate">https://developer.mozilla.org/en-US/search?locale=en-US&amp;kumascript_macros=<var>TemplateLink</var></pre>

<p>This searches for uses of the macro {{TemplateLink("TemplateLink")}}. This lets us find macros whose parameters have changed, or that we wish to stop using.</p>

<h3 id="JSON_response_body_format">JSON response body format</h3>

<p>When you request the results in JSON format, you still receive the results one page at a time. Each page is a KumaScript object which consists of several pieces of metadata about the results, plus an array of standard page objects with the addition of one extra field: the URL to begin editing the page.</p>

<p>The data contained in the resulting object is:</p>

<dl>
 <dt><code>count</code></dt>
 <dd>The total number of results found.</dd>
 <dt><code>next</code></dt>
 <dd>A URL that will return the next page of results (or {{JSxRef("Global_Objects/null", "null")}} on the last page).</dd>
 <dt><code>previous</code></dt>
 <dd>A URL that will return the previous page of results (or {{JSxRef("Global_Objects/null", "null")}}, for the first page).</dd>
 <dt><code>query</code></dt>
 <dd>The search query that was used to find the results.</dd>
 <dt><code>page</code></dt>
 <dd>The page number of the results that are described by this object.</dd>
 <dt><code>pages</code></dt>
 <dd>The total number of pages in the results.</dd>
 <dt><code>start</code></dt>
 <dd>The item number of the first item in this page of results.</dd>
 <dt><code>end</code></dt>
 <dd>The item number of the last item in this page of results.</dd>
 <dt><code>filters</code></dt>
 <dd>An array of the configurations of the various search filters. These are the filters available to the standard search.</dd>
 <dt><code>documents</code></dt>
 <dd>An array of {{anch("Page objects")}} describing each matching page.</dd>
</dl>

<h4 id="Page_objects">Page objects</h4>

<p>Each page object contains the following fields:</p>

<dl>
 <dt><code>title</code></dt>
 <dd>The article's title.</dd>
 <dt><code>slug</code></dt>
 <dd>The article's slug. This is everything in the URL of the page following the locale and the subsequent slash character.</dd>
 <dt><code>locale</code></dt>
 <dd>The page's locale.</dd>
 <dt><code>excerpt</code></dt>
 <dd>A snippet of the page's content; this is either the first block of regular text in the article or, if available, the content marked with the "SEO Summary" class. The excerpt will contain <code><a href="/en-US/docs/Web/HTML/Element/mark">&lt;mark&gt;</a></code> elements unless you specify <code>highlight=false</code> in the <a href="#Search_query_format">search query parameters</a>.</dd>
 <dt><code>url</code></dt>
 <dd>The full URL for the page.</dd>
 <dt><code>edit_url</code></dt>
 <dd>The full URL to get into edit mode for the page.</dd>
 <dt><code>tags</code></dt>
 <dd>An array of the page's tags.</dd>
 <dt><code>score</code></dt>
 <dd>A scoring value assigned by the search engine.</dd>
 <dt><code>explanation</code></dt>
 <dd>Assorted information from the search engine about how and why the page matched your query. The description of this content is beyond the scope of this document.</dd>
</dl>

<h2 id="See_also">See also</h2>

<p>There are some additional <a href="/en-US/docs/MDN/Kuma/Getting_started#Finding_pages">admin-only search functions</a> for things like finding pages whose slugs start with a specific string, for example.</p>
